/*
 *    MCreator note:
 *
 *    If you lock base mod element files, you can edit this file and it won't get overwritten.
 *    If you change your modid or package, you need to apply these changes to this file MANUALLY.
 *
 *    Settings in @Mod annotation WON'T be changed in case of the base mod element
 *    files lock too, so you need to set them manually here in such case.
 *
 *    If you do not lock base mod element files in Workspace settings, this file
 *    will be REGENERATED on each build.
 *
 */
package net.mcreator.testmore;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import net.minecraftforge.network.simple.SimpleChannel;
import net.minecraftforge.network.NetworkRegistry;
import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.IEventBus;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.FriendlyByteBuf;

import net.mcreator.testmore.init.TestmoreModTabs;
import net.mcreator.testmore.init.TestmoreModPotions;
import net.mcreator.testmore.init.TestmoreModParticleTypes;
import net.mcreator.testmore.init.TestmoreModMobEffects;
import net.mcreator.testmore.init.TestmoreModItems;
import net.mcreator.testmore.init.TestmoreModFeatures;
import net.mcreator.testmore.init.TestmoreModEntities;
import net.mcreator.testmore.init.TestmoreModEnchantments;
import net.mcreator.testmore.init.TestmoreModBlocks;

import java.util.function.Supplier;
import java.util.function.Function;
import java.util.function.BiConsumer;

@Mod("testmore")
public class TestmoreMod {
	public static final Logger LOGGER = LogManager.getLogger(TestmoreMod.class);
	public static final String MODID = "testmore";
	private static final String PROTOCOL_VERSION = "1";
	public static final SimpleChannel PACKET_HANDLER = NetworkRegistry.newSimpleChannel(new ResourceLocation(MODID, MODID), () -> PROTOCOL_VERSION,
			PROTOCOL_VERSION::equals, PROTOCOL_VERSION::equals);
	private static int messageID = 0;

	public TestmoreMod() {
		TestmoreModTabs.load();
		IEventBus bus = FMLJavaModLoadingContext.get().getModEventBus();
		TestmoreModBlocks.REGISTRY.register(bus);
		TestmoreModItems.REGISTRY.register(bus);
		TestmoreModEntities.REGISTRY.register(bus);

		TestmoreModFeatures.REGISTRY.register(bus);

		TestmoreModEnchantments.REGISTRY.register(bus);
		TestmoreModMobEffects.REGISTRY.register(bus);
		TestmoreModPotions.REGISTRY.register(bus);

		TestmoreModParticleTypes.REGISTRY.register(bus);
	}

	public static <T> void addNetworkMessage(Class<T> messageType, BiConsumer<T, FriendlyByteBuf> encoder, Function<FriendlyByteBuf, T> decoder,
			BiConsumer<T, Supplier<NetworkEvent.Context>> messageConsumer) {
		PACKET_HANDLER.registerMessage(messageID, messageType, encoder, decoder, messageConsumer);
		messageID++;
	}
}
