
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.testmore.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;

import net.minecraft.world.level.block.Block;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.BlockItem;

import net.mcreator.testmore.item.WitherSwordItem;
import net.mcreator.testmore.item.TenSecondCreativeModeItem;
import net.mcreator.testmore.item.SwordOfBloodItem;
import net.mcreator.testmore.item.StoneOfBlessingItem;
import net.mcreator.testmore.item.OnlyNAItem;
import net.mcreator.testmore.item.NetheriteBowItem;
import net.mcreator.testmore.item.NetheriteAppleItem;
import net.mcreator.testmore.item.DiamondBowItem;
import net.mcreator.testmore.item.DiamondAppleItem;
import net.mcreator.testmore.item.BlessedSwordItem;
import net.mcreator.testmore.item.BlessedPickaxeItem;
import net.mcreator.testmore.item.AncientCoalItem;
import net.mcreator.testmore.TestmoreMod;

public class TestmoreModItems {
	public static final DeferredRegister<Item> REGISTRY = DeferredRegister.create(ForgeRegistries.ITEMS, TestmoreMod.MODID);
	public static final RegistryObject<Item> LUCKY_BLOCK = block(TestmoreModBlocks.LUCKY_BLOCK, TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD);
	public static final RegistryObject<Item> STONE_OF_BLESSING = REGISTRY.register("stone_of_blessing", () -> new StoneOfBlessingItem());
	public static final RegistryObject<Item> BLESSED_ORE = block(TestmoreModBlocks.BLESSED_ORE, TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD);
	public static final RegistryObject<Item> BLESSED_SWORD = REGISTRY.register("blessed_sword", () -> new BlessedSwordItem());
	public static final RegistryObject<Item> BLESSED_PICKAXE = REGISTRY.register("blessed_pickaxe", () -> new BlessedPickaxeItem());
	public static final RegistryObject<Item> TEN_SECOND_CREATIVE_MODE = REGISTRY.register("ten_second_creative_mode",
			() -> new TenSecondCreativeModeItem());
	public static final RegistryObject<Item> WITHER_SWORD = REGISTRY.register("wither_sword", () -> new WitherSwordItem());
	public static final RegistryObject<Item> ANCIENT_COAL = REGISTRY.register("ancient_coal", () -> new AncientCoalItem());
	public static final RegistryObject<Item> ONLY_NA_HELMET = REGISTRY.register("only_na_helmet", () -> new OnlyNAItem.Helmet());
	public static final RegistryObject<Item> ONLY_NA_CHESTPLATE = REGISTRY.register("only_na_chestplate", () -> new OnlyNAItem.Chestplate());
	public static final RegistryObject<Item> ONLY_NA_LEGGINGS = REGISTRY.register("only_na_leggings", () -> new OnlyNAItem.Leggings());
	public static final RegistryObject<Item> ONLY_NA_BOOTS = REGISTRY.register("only_na_boots", () -> new OnlyNAItem.Boots());
	public static final RegistryObject<Item> DIAMOND_BOW = REGISTRY.register("diamond_bow", () -> new DiamondBowItem());
	public static final RegistryObject<Item> DIAMOND_APPLE = REGISTRY.register("diamond_apple", () -> new DiamondAppleItem());
	public static final RegistryObject<Item> NETHERITE_APPLE = REGISTRY.register("netherite_apple", () -> new NetheriteAppleItem());
	public static final RegistryObject<Item> NETHERITE_BOW = REGISTRY.register("netherite_bow", () -> new NetheriteBowItem());
	public static final RegistryObject<Item> SWORD_OF_BLOOD = REGISTRY.register("sword_of_blood", () -> new SwordOfBloodItem());

	private static RegistryObject<Item> block(RegistryObject<Block> block, CreativeModeTab tab) {
		return REGISTRY.register(block.getId().getPath(), () -> new BlockItem(block.get(), new Item.Properties().tab(tab)));
	}
}
