
package net.mcreator.testmore.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.PickaxeItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;

import net.mcreator.testmore.init.TestmoreModTabs;
import net.mcreator.testmore.init.TestmoreModItems;

import java.util.List;

public class BlessedPickaxeItem extends PickaxeItem {
	public BlessedPickaxeItem() {
		super(new Tier() {
			public int getUses() {
				return 12551;
			}

			public float getSpeed() {
				return 16f;
			}

			public float getAttackDamageBonus() {
				return 6f;
			}

			public int getLevel() {
				return 4;
			}

			public int getEnchantmentValue() {
				return 5;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(TestmoreModItems.STONE_OF_BLESSING.get()));
			}
		}, 1, -3f, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD).fireResistant());
	}

	@Override
	public void appendHoverText(ItemStack itemstack, Level world, List<Component> list, TooltipFlag flag) {
		super.appendHoverText(itemstack, world, list, flag);
		list.add(new TextComponent("A pickaxe made from the powerful Stone of Blessing"));
	}
}
