
package net.mcreator.testmore.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.SwordItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;

import net.mcreator.testmore.init.TestmoreModTabs;
import net.mcreator.testmore.init.TestmoreModItems;

import java.util.List;

public class BlessedSwordItem extends SwordItem {
	public BlessedSwordItem() {
		super(new Tier() {
			public int getUses() {
				return 12251;
			}

			public float getSpeed() {
				return 4f;
			}

			public float getAttackDamageBonus() {
				return 13f;
			}

			public int getLevel() {
				return 1;
			}

			public int getEnchantmentValue() {
				return 100;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(TestmoreModItems.STONE_OF_BLESSING.get()));
			}
		}, 3, 96f, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD).fireResistant());
	}

	@Override
	public void appendHoverText(ItemStack itemstack, Level world, List<Component> list, TooltipFlag flag) {
		super.appendHoverText(itemstack, world, list, flag);
		list.add(new TextComponent("A special Sword made of the Stone of Blessing - The most Powerful Sword in the game!"));
	}
}
