
package net.mcreator.testmore.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.Rarity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.food.FoodProperties;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;

import net.mcreator.testmore.procedures.NetheriteAppleProcedureProcedure;
import net.mcreator.testmore.init.TestmoreModTabs;

import java.util.List;

public class NetheriteAppleItem extends Item {
	public NetheriteAppleItem() {
		super(new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD).stacksTo(16).fireResistant().rarity(Rarity.EPIC)
				.food((new FoodProperties.Builder()).nutrition(25).saturationMod(0.7f).alwaysEat()

						.build()));
	}

	@Override
	public int getUseDuration(ItemStack itemstack) {
		return 18;
	}

	@Override
	public void appendHoverText(ItemStack itemstack, Level world, List<Component> list, TooltipFlag flag) {
		super.appendHoverText(itemstack, world, list, flag);
		list.add(new TextComponent("Even More Powerful Than The Diamond Apple. Don't waste this. Its extremely powerful and rare"));
	}

	@Override
	public ItemStack finishUsingItem(ItemStack itemstack, Level world, LivingEntity entity) {
		ItemStack retval = super.finishUsingItem(itemstack, world, entity);
		double x = entity.getX();
		double y = entity.getY();
		double z = entity.getZ();

		NetheriteAppleProcedureProcedure.execute(entity);
		return retval;
	}
}
