
package net.mcreator.testmore.item;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.world.item.Tier;
import net.minecraft.world.item.SwordItem;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;

import net.mcreator.testmore.init.TestmoreModTabs;

import java.util.List;

public class SwordOfBloodItem extends SwordItem {
	public SwordOfBloodItem() {
		super(new Tier() {
			public int getUses() {
				return 521;
			}

			public float getSpeed() {
				return 2f;
			}

			public float getAttackDamageBonus() {
				return 5f;
			}

			public int getLevel() {
				return 1;
			}

			public int getEnchantmentValue() {
				return 18;
			}

			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(Items.REDSTONE));
			}
		}, 3, 1f, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD).fireResistant());
	}

	@Override
	public void appendHoverText(ItemStack itemstack, Level world, List<Component> list, TooltipFlag flag) {
		super.appendHoverText(itemstack, world, list, flag);
		list.add(new TextComponent("The only item Lifesteal will apply to. Low Attack Damaga"));
		list.add(new TextComponent(
				"but very good with a higher level of The Lifesteal Enchant. You will get the enchant from the 10 Second Creative Item which can also be found in the Lucky Block. It also has a low probability of appearing in villager trades."));
	}
}
